"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.XmlValidator = exports.defaultOptions = void 0;
const jsdom_1 = require("jsdom");
exports.defaultOptions = {
    userAgent: "xml-validator",
};
class XmlValidator {
    constructor(options) {
        this.options = Object.assign(Object.assign({}, exports.defaultOptions), options);
    }
    validate(content, type = "application/xml") {
        const result = {
            error: "",
            isValid: false,
        };
        try {
            new jsdom_1.JSDOM(content, {
                contentType: type,
                userAgent: this.options.userAgent,
            });
            result.isValid = true;
        }
        catch (error) {
            if (error instanceof Error) {
                result.error = error.message.replace("about:blank", "");
            }
        }
        return result;
    }
    validateFile(url, type = "application/xml") {
        return __awaiter(this, void 0, void 0, function* () {
            const result = {
                error: "",
                isValid: false,
            };
            try {
                yield jsdom_1.JSDOM.fromFile(url, {
                    contentType: type,
                    userAgent: this.options.userAgent,
                });
                result.isValid = true;
            }
            catch (error) {
                if (error instanceof Error) {
                    result.error = error.message.replace("about:blank", "");
                }
            }
            return result;
        });
    }
    validateUrl(url) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = {
                error: "",
                isValid: false,
            };
            try {
                yield jsdom_1.JSDOM.fromURL(url, {
                    userAgent: this.options.userAgent,
                });
                result.isValid = true;
            }
            catch (error) {
                if (error instanceof Error) {
                    result.error = error.message.replace("about:blank", "");
                }
            }
            return result;
        });
    }
}
exports.XmlValidator = XmlValidator;
